"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from clerk_backend_api.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from clerk_backend_api.utils import FieldMetadata, PathParamMetadata, RequestMetadata
from pydantic import model_serializer
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class CreateOrganizationDomainRequestBodyTypedDict(TypedDict):
    name: NotRequired[str]
    r"""The name of the new domain"""
    enrollment_mode: NotRequired[str]
    r"""The enrollment_mode for the new domain. This can be `automatic_invitation`, `automatic_suggestion` or `manual_invitation`"""
    verified: NotRequired[Nullable[bool]]
    r"""The status of domain's verification. Defaults to true"""


class CreateOrganizationDomainRequestBody(BaseModel):
    name: Optional[str] = None
    r"""The name of the new domain"""

    enrollment_mode: Optional[str] = None
    r"""The enrollment_mode for the new domain. This can be `automatic_invitation`, `automatic_suggestion` or `manual_invitation`"""

    verified: OptionalNullable[bool] = UNSET
    r"""The status of domain's verification. Defaults to true"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["name", "enrollment_mode", "verified"]
        nullable_fields = ["verified"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m


class CreateOrganizationDomainRequestTypedDict(TypedDict):
    organization_id: str
    r"""The ID of the organization where the new domain will be created."""
    request_body: CreateOrganizationDomainRequestBodyTypedDict


class CreateOrganizationDomainRequest(BaseModel):
    organization_id: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""The ID of the organization where the new domain will be created."""

    request_body: Annotated[
        CreateOrganizationDomainRequestBody,
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ]
