"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from clerk_backend_api.types import BaseModel
from clerk_backend_api.utils import FieldMetadata, QueryParamMetadata
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class ListOrganizationsRequestTypedDict(TypedDict):
    limit: NotRequired[int]
    r"""Applies a limit to the number of results returned.
    Can be used for paginating the results together with `offset`.
    """
    offset: NotRequired[int]
    r"""Skip the first `offset` results when paginating.
    Needs to be an integer greater or equal to zero.
    To be used in conjunction with `limit`.
    """
    include_members_count: NotRequired[bool]
    r"""Flag to denote whether the member counts of each organization should be included in the response or not."""
    query: NotRequired[str]
    r"""Returns organizations with ID, name, or slug that match the given query.
    Uses exact match for organization ID and partial match for name and slug.
    """
    order_by: NotRequired[str]
    r"""Allows to return organizations in a particular order.
    At the moment, you can order the returned organizations either by their `name`, `created_at` or `members_count`.
    In order to specify the direction, you can use the `+/-` symbols prepended in the property to order by.
    For example, if you want organizations to be returned in descending order according to their `created_at` property, you can use `-created_at`.
    If you don't use `+` or `-`, then `+` is implied.
    Defaults to `-created_at`.
    """


class ListOrganizationsRequest(BaseModel):
    limit: Annotated[
        Optional[int],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = 10
    r"""Applies a limit to the number of results returned.
    Can be used for paginating the results together with `offset`.
    """

    offset: Annotated[
        Optional[int],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = 0
    r"""Skip the first `offset` results when paginating.
    Needs to be an integer greater or equal to zero.
    To be used in conjunction with `limit`.
    """

    include_members_count: Annotated[
        Optional[bool],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""Flag to denote whether the member counts of each organization should be included in the response or not."""

    query: Annotated[
        Optional[str],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""Returns organizations with ID, name, or slug that match the given query.
    Uses exact match for organization ID and partial match for name and slug.
    """

    order_by: Annotated[
        Optional[str],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = "-created_at"
    r"""Allows to return organizations in a particular order.
    At the moment, you can order the returned organizations either by their `name`, `created_at` or `members_count`.
    In order to specify the direction, you can use the `+/-` symbols prepended in the property to order by.
    For example, if you want organizations to be returned in descending order according to their `created_at` property, you can use `-created_at`.
    If you don't use `+` or `-`, then `+` is implied.
    Defaults to `-created_at`.
    """
